#include<iostream>
#include<stdlib.h>
#include"hash.h"

unsigned int Hash::operator()(const char *str)
{
    falter->reset();
    for(const char *p=str;*p!='\0';p++) falter->put(*p);
    return (*hash)(breite,falter->getfaltung());
}


unsigned int hash2pmodulo(int breite,unsigned long f)
{
    unsigned long maske = (1L<<breite)-1;
    return (unsigned int)(f&maske);
}

unsigned int hashfaltung(int breite,unsigned long f)
{
    unsigned long ret=0;
    unsigned long maske = (1L<<breite)-1;
    while(f!=0)
    {
      ret=(ret^(f&maske));
      f>>=breite;
    }
    return (unsigned int)ret;
}

#ifdef HASH_EXP
void main(int argc,char **argv)
{
   int breite=atoi(argv[1]);
   unsigned long faltung=atol(argv[2]);
   std::cout << hash2pmodulo(breite,faltung) << ' '
	<< hashfaltung(breite,faltung)  << std::endl;
}
#endif

